QCPItemPixmap Class Reference

An arbitrary pixmap. More...

Inheritance diagram for QCPItemPixmap:

## Public Member Functions

| QCPItemPixmap (QCustomPlot *parentPlot)
QPixmap | pixmap () const
bool | scaled () const
Qt::AspectRatioMode | aspectRatioMode () const
QPen | pen () const
QPen | selectedPen () const
void | setPixmap (const QPixmap &pixmap)
void | setScaled (bool scaled, Qt::AspectRatioMode aspectRatioMode=Qt::KeepAspectRatio)
void | setPen (const QPen &pen)
void | setSelectedPen (const QPen &pen)
virtual double | selectTest (const QPointF &pos, bool onlySelectable, QVariant *details=0) const
Public Member Functions inherited from QCPAbstractItem
| QCPAbstractItem (QCustomPlot *parentPlot)
bool | clipToAxisRect () const
QCPAxisRect * | clipAxisRect () const
bool | selectable () const
bool | selected () const
void | setClipToAxisRect (bool clip)
void | setClipAxisRect (QCPAxisRect *rect)
void | setSelectable (bool selectable)
void | setSelected (bool selected)
QList< QCPItemPosition * > | positions () const
QList< QCPItemAnchor * > | anchors () const
QCPItemPosition * | position (const QString &name) const
QCPItemAnchor * | anchor (const QString &name) const
bool | hasAnchor (const QString &name) const
Public Member Functions inherited from QCPLayerable
| QCPLayerable (QCustomPlot *plot, QString targetLayer="", QCPLayerable *parentLayerable=0)
bool | visible () const
QCustomPlot * | parentPlot () const
QCPLayerable * | parentLayerable () const
QCPLayer * | layer () const
bool | antialiased () const
void | setVisible (bool on)
bool | setLayer (QCPLayer *layer)
bool | setLayer (const QString &layerName)
void | setAntialiased (bool enabled)
bool | realVisibility () const

## Public Attributes

QCPItemPosition *const | topLeft
QCPItemPosition *const | bottomRight
QCPItemAnchor *const | top
QCPItemAnchor *const | topRight
QCPItemAnchor *const | right
QCPItemAnchor *const | bottom
QCPItemAnchor *const | bottomLeft
QCPItemAnchor *const | left

## Protected Types

enum | AnchorIndex { aiTop, aiTopRight, aiRight, aiBottom, aiBottomLeft, aiLeft }

## Protected Member Functions

virtual void | draw (QCPPainter *painter)
virtual QPointF | anchorPixelPoint (int anchorId) const
void | updateScaledPixmap (QRect finalRect=QRect(), bool flipHorz=false, bool flipVert=false)
QRect | getFinalRect (bool *flippedHorz=0, bool *flippedVert=0) const
QPen | mainPen () const
Protected Member Functions inherited from QCPAbstractItem
virtual QCP::Interaction | selectionCategory () const
virtual QRect | clipRect () const
virtual void | applyDefaultAntialiasingHint (QCPPainter *painter) const
virtual void | selectEvent (QMouseEvent *event, bool additive, const QVariant &details, bool *selectionStateChanged)
virtual void | deselectEvent (bool *selectionStateChanged)
double | distSqrToLine (const QPointF &start, const QPointF &end, const QPointF &point) const
double | rectSelectTest (const QRectF &rect, const QPointF &pos, bool filledRect) const
QCPItemPosition * | createPosition (const QString &name)
QCPItemAnchor * | createAnchor (const QString &name, int anchorId)
Protected Member Functions inherited from QCPLayerable
virtual void | parentPlotInitialized (QCustomPlot *parentPlot)
void | initializeParentPlot (QCustomPlot *parentPlot)
void | setParentLayerable (QCPLayerable *parentLayerable)
bool | moveToLayer (QCPLayer *layer, bool prepend)
void | applyAntialiasingHint (QCPPainter *painter, bool localAntialiased, QCP::AntialiasedElement overrideElement) const

## Protected Attributes

QPixmap | mPixmap
QPixmap | mScaledPixmap
bool | mScaled
Qt::AspectRatioMode | mAspectRatioMode
QPen | mPen
QPen | mSelectedPen
Protected Attributes inherited from QCPAbstractItem
bool | mClipToAxisRect
QPointer< QCPAxisRect > | mClipAxisRect
QList< QCPItemPosition * > | mPositions
QList< QCPItemAnchor * > | mAnchors
bool | mSelectable
bool | mSelected
Protected Attributes inherited from QCPLayerable
bool | mVisible
QCustomPlot * | mParentPlot
QPointer< QCPLayerable > | mParentLayerable
QCPLayer * | mLayer
bool | mAntialiased

## Additional Inherited Members

Signals inherited from QCPAbstractItem
void | selectionChanged (bool selected)

## Detailed Description

An arbitrary pixmap.

Pixmap example. Blue dotted circles are anchors, solid blue discs are positions.

It has two positions, topLeft and bottomRight, which define the rectangle the pixmap will be drawn in. Depending on the scale setting (setScaled), the pixmap will be either scaled to fit the rectangle or be drawn aligned to the topLeft position.

If scaling is enabled and topLeft is further to the bottom/right than bottomRight (as shown on the right side of the example image), the pixmap will be flipped in the respective orientations.

## Constructor & Destructor Documentation

QCPItemPixmap::QCPItemPixmap | ( | QCustomPlot * | parentPlot | ) |

Creates a rectangle item and sets default values.

The constructed item can be added to the plot with QCustomPlot::addItem.

## Member Function Documentation

double QCPItemPixmap::selectTest | ( | const QPointF & | pos,
|  | bool | onlySelectable,
|  | QVariant * | details = `0`
| ) |  | const

virtual

This function is used to decide whether a click hits a layerable object or not.

pos is a point in pixel coordinates on the QCustomPlot surface. This function returns the shortest pixel distance of this point to the object. If the object is either invisible or the distance couldn't be determined, -1.0 is returned. Further, if onlySelectable is true and the object is not selectable, -1.0 is returned, too.

If the item is represented not by single lines but by an area like QCPItemRect or QCPItemText, a click inside the area returns a constant value greater zero (typically the selectionTolerance of the parent QCustomPlot multiplied by 0.99). If the click lies outside the area, this function returns -1.0.

Providing a constant value for area objects allows selecting line objects even when they are obscured by such area objects, by clicking close to the lines (i.e. closer than 0.99*selectionTolerance).

The actual setting of the selection state is not done by this function. This is handled by the parent QCustomPlot when the mouseReleaseEvent occurs, and the finally selected object is notified via the selectEvent/deselectEvent methods.

details is an optional output parameter. Every layerable subclass may place any information in details. This information will be passed to selectEvent when the parent QCustomPlot decides on the basis of this selectTest call, that the object was successfully selected. The subsequent call to selectEvent will carry the details. This is useful for multi-part objects (like QCPAxis). This way, a possibly complex calculation to decide which part was clicked is only done once in selectTest. The result (i.e. the actually clicked part) can then be placed in details. So in the subsequent selectEvent, the decision which part was selected doesn't have to be done a second time for a single selection operation.

You may pass 0 as details to indicate that you are not interested in those selection details.

See also
  selectEvent, deselectEvent, QCustomPlot::setInteractions

Implements QCPAbstractItem.

void QCPItemPixmap::setPen | ( | const QPen & | pen | ) |

Sets the pen that will be used to draw a border around the pixmap.

See also
  setSelectedPen, setBrush

void QCPItemPixmap::setPixmap | ( | const QPixmap & | pixmap | ) |

Sets the pixmap that will be displayed.

void QCPItemPixmap::setScaled | ( | bool | scaled,
|  | Qt::AspectRatioMode | aspectRatioMode = `Qt::KeepAspectRatio`
| ) |  |

Sets whether the pixmap will be scaled to fit the rectangle defined by the topLeft and bottomRight positions.

void QCPItemPixmap::setSelectedPen | ( | const QPen & | pen | ) |

Sets the pen that will be used to draw a border around the pixmap when selected

See also
  setPen, setSelected

The documentation for this class was generated from the following files:

- qcustomplot.h
- qcustomplot.cpp